from os.path import join, exists, abspath, dirname
import os
import sys
import subprocess
import shutil

PROJECT_ROOT = abspath(dirname(__file__))
REQUIREMENTS = join(PROJECT_ROOT, 'requirements.txt')

VE_ROOT = join(PROJECT_ROOT, 'env')


def go_to_ve():
    # going into ve
    if not sys.prefix == VE_ROOT:
        if sys.platform == 'win32':
            python = join(VE_ROOT, 'Scripts', 'python.exe')
        else:
            python = join(VE_ROOT, 'bin', 'python')

        retcode = subprocess.call([python, __file__] + sys.argv[1:])
        sys.exit(retcode)

delete_ve = 'del_ve' in sys.argv or 'delete_ve' in sys.argv
if delete_ve:
    if exists(VE_ROOT):
        print 'Deleting env...'
        shutil.rmtree(VE_ROOT)
        print 'Done.'
        sys.exit(0)

update_ve = 'up_ve' in sys.argv or 'update_ve' in sys.argv
if update_ve:
    # install ve
    if not exists(VE_ROOT):
        import virtualenv
        print 'Creating virtualenv...'
        virtualenv.logger = virtualenv.Logger(consumers=[])
        virtualenv.create_environment(VE_ROOT, site_packages=False)
        print 'Done.'

    go_to_ve()
    # check requirements
    import pip
    pip.main(['install', '-r', REQUIREMENTS])
    sys.exit(0)

if exists(VE_ROOT):
    go_to_ve()
    # print 'Found virtualenv. Entering...'

try:
    import settings
except ImportError:
    import sys
    sys.stderr.write("Error: Can't find the file 'settings.py' in the directory")
    sys.exit(1)

if __name__ == '__main__':
    if not delete_ve:
        os.environ.setdefault('DJANGO_SETTINGS_MODULE', 'settings')

        from django.core.management import execute_from_command_line
        execute_from_command_line(sys.argv)
