# -*- coding: utf-8 -*-
from __future__ import unicode_literals
from admin_tools.dashboard import modules, Dashboard, AppIndexDashboard


class CustomIndexDashboard(Dashboard):
    def init_with_context(self, context):
        self.children.append(
            modules.ModelList(
                title='Система управления содержимым',
                models=('cms.models.pagemodel.Page', )
            ))

        self.children.append(
            modules.ModelList(
                title='Все пользователи',
                models=('email_auth.models.User',
                        'django.contrib.auth.models.Group')
            ))


class CustomAppIndexDashboard(AppIndexDashboard):
    # we disable title because its redundant with the model list module
    title = ''

    def __init__(self, *args, **kwargs):
        AppIndexDashboard.__init__(self, *args, **kwargs)

        self.children += [modules.ModelList(self.app_title, self.models), ]

    def init_with_context(self, context):
        """
        Use this method if you need to access the request context.
        """
        return super(CustomAppIndexDashboard, self).init_with_context(context)
