from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.utils.functional import curry
from django.views.defaults import permission_denied, page_not_found, server_error
from django.views.generic import TemplateView

from django.contrib import admin

admin.autodiscover()

handler403 = curry(permission_denied, exception=Exception('Permission Denied'), template_name='errs/403.html')
handler404 = curry(page_not_found, exception=Exception('Page not Found'), template_name='errs/404.html')
handler500 = curry(server_error, template_name='errs/500.html')

urlpatterns = [
    url(r'^admin/', include(admin.site.urls)),
    url(r'^admin_tools/', include('admin_tools.urls')),

    # url(r'^specs/$', user_passes_test(lambda u: u.is_superuser)(TemplateView.as_view(template_name='spec/specs.html')), name='specs'),

    url(r'^', include('cms.urls')),

    # verifications
    url(r'^google0592405c1674dd67.html$', TemplateView.as_view(template_name='vers/google0592405c1674dd67.html')),
    url(r'^yandex_576bad7755b3ffd1.html$', TemplateView.as_view(template_name='vers/yandex_576bad7755b3ffd1.html')),
    url(r'^wmail_e9fe7f28542af184.html$', TemplateView.as_view(template_name='vers/wmail_e9fe7f28542af184.html')),
]

if settings.DEBUG:
    urlpatterns = [
        # --- error pages ---
        url(r'^403$', handler403),
        url(r'^404$', handler404),
        url(r'^500$', handler500),
    ] + urlpatterns

urlpatterns.extend(static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT))
